
    SEI
    CLD
    LDA #$08
    STA $2000
    LDA #$00
    STA $2001
WAIT1:
    LDA $2002
    BMI WAIT1
WAIT2:
    LDA $2002
    BPL WAIT2
WAIT3:
    LDA $2002
    BMI WAIT3
    LDX #$FF
    TXS
    JSR HIDESPRITES
    JSR DRAWSPRITE
    LDA #$14
    STA $0430
    LDA #$07
    STA $0448
    LDA #$01
    STA <$4C
    JSR SETPRGROM
    LDA #$00
    STA <MAPNMBR
    AND #$3F
    ASL A
    TAY
    LDA MAPTABLE, Y
    STA <$4F
    LDA MAPTABLE + 1, Y
    STA <$50
    JSR SETUPMAP
    JSR DRAWSCREEN
    JSR PALETTE

    LDA #$00                   ;SET THE HORIZONTAL AND VERTICAL SCROLL TO ZERO
    STA $2005
    STA $2005
    LDA #$88                   ;TURN THE NMI ON
    STA $2000
    STA <CNTREG1
    LDA #$18                   ;TURN THE SCREEN ON
    STA $2001
    STA <CNTREG2
    JMP MAINLOOP               ;THIS IS WHERE ALL THE ACTION TAKES PLACE

HIDESPRITES:
    LDA #$00
HIDESPRITELOOP:
    TAY                        ;
    LDA #$F8                   ;SET ALL SPRITE Y COORDINATES TO #$F8 (OFF BOTTOM OF SCREEN)
    STA $0200, Y
    STA $0204, Y
    STA $0208, Y
    STA $020C, Y
    TYA
    CLC
    ADC #$04
    BNE HIDESPRITELOOP
    RTS

DRAWSPRITE:
    LDA #$6F
    STA $0200
    STA $0204
    LDA #$77
    STA $0208
    STA $020C
    LDA #$80
    STA $0203
    STA $020B
    LDA #$88
    STA $0207
    STA $020F
    LDA #$00
    STA $0202
    STA $0206
    STA $020A
    STA $020E
    RTS

PALETTE:
    LDX #$00
    LDY #$20
    LDA #$3F
    STA $2006
    STX $2006
PALETTELOOP:
    LDA $0728, X
    STA $2007
    INX
    DEY
    BNE PALETTELOOP
    LDA #$3F
    STA $2006
    STY $2006
    STY $2006
    STY $2006
    RTS

